<?php
/**
 * @file
 * Blocks fucntions.
 */

/**
 * Get weather content.
 */
function _tm_blocks_get_weather() {
  global $language;
  switch ($language->language) {
    case 'es':
      $lang = 'sp';
      break;

    default:
      $lang = 'en';
      break;
  }
  $content = array();
  $content['date'] = array(
    '#prefix' => '<div class="tm-weater-date">',
    '#suffix' => '</div>',
    '#markup' => format_date(REQUEST_TIME, 'tm_long'),
  );

  $request = drupal_http_request('http://api.openweathermap.org/data/2.5/weather?q=Bogotá,co&lang=' . $lang);
  if ($request->code == 200) {
    $data = drupal_json_decode($request->data);
    if ($data['cod'] == 200) {
      $img_vars = array(
        'path' => isset($data['weather'][0]['icon']) ? 'http://openweathermap.org/img/w/' . $data['weather'][0]['icon'] . '.png' : NULL,
        'width' => 50,
        'height' => 50,
        'alt' => isset($data['weather'][0]['description']) ? $data['weather'][0]['description'] : 'Bogotá',
        'title' => isset($data['weather'][0]['description']) ? drupal_ucfirst($data['weather'][0]['description']) : 'Bogotá',
        'attributes' => array(
          'class' => array(drupal_html_class('tm-weather-weather')),
        ),
      );
      $content['weather'] = array(
        '#prefix' => '<div class="tm-weater">',
        '#suffix' => '</div>',
        'image' => array(
          '#prefix' => '<div class="tm-weater-img">',
          '#suffix' => '</div>',
          '#markup' => theme('image', $img_vars),
        ),
        // Se restan 273.15 para conversión a grados centigrados.
        'tem' => array(
          '#prefix' => '<div class="tm-weater-tem">',
          '#suffix' => '</div>',
          '#markup' => isset($data['main']['temp']) ? '<span>' . number_format(($data['main']['temp'] - 273.15)) . '</span>° C' : '',
        ),
        'desc' => array(
          '#prefix' => '<span class="tm-weater-desc">',
          '#suffix' => '</span>',
          '#markup' => isset($data['weather'][0]['description']) ? drupal_ucfirst($data['weather'][0]['description']) : t('Bogotá weather')
        ),
      );
    }

  }
  $content['hour'] = array(
    '#prefix' => '<div class="tm-weater-hour">',
    '#suffix' => '</div>',
    '#markup' => '<span>Bogotá D.C<span>' . isset($data['dt']) ? date('H:i a', $data['dt']) : '',
  );

  return $content;
}

/**
 * Banner home links.
 */
function _tm_blocks_get_home_banner_links() {
  $content = array();
  $content['tp'] = array(
    '#prefix' => '<div class="tm-blh-tp">',
    '#suffix' => '</div>',
    '#markup' => l(t('My travel plan'), 'node/237', array('attributes' => array('class' => array('tm-mtp')))),
  );
  $content['hust'] = array(
    '#prefix' => '<div class="tm-blh-hust">',
    '#suffix' => '</div>',
    '#markup' => l(t('How to use the system'), 'node/207', array('attributes' => array('class' => array('tm-huts')))),
  );
  $content['cp'] = array(
    '#prefix' => '<div class="tm-blh-cp">',
    '#suffix' => '</div>',
    '#markup' => l(t('Child portal'), 'http://www.transmilenio.gov.co/WebSiteInfantil/index.html', array(
      'attributes' => array(
        'class' => array('tm-cp'),
        'target' => '_blank'
      ),
      'external' => TRUE
      )
    ),
  );
  return $content;
}

/**
 * Banner home visitor.
 */
function _tm_blocks_get_home_visitors() {
  $content = array();
  $vits = _tm_menu_get_page_hits('home') ;
  $content['arrow'] = array(
    '#type' => 'container',
    '#attributes' => array(
      'class' => array('tm-arrow-vst'),
    ),
  );
  $content['tp'] = array(
    '#prefix' => '<span class="tm-count-vst">',
    '#suffix' => '</span>',
    '#markup' => t('Number of visitors'),
  );
  $content['hust'] = array(
    '#prefix' => '<div class="tm-count-vst-tt">',
    '#suffix' => '</div>',
    '#markup' => isset($vits['hits']) ? number_format($vits['hits'] + 8104604, 0, '', '.') : 0,
  );
  

  $content['last_update'] = array(
    '#prefix' => '<div class="tm-count-last-update">',
    '#suffix' => '</div>',
    '#markup' => _tm_blocks_get_last_update(),
  );

  
  return $content;
}

/**
 * Home Galleries.
 */
function _tm_blocks_get_home_galleries() {
   $content = array();
  global $language;
  switch ($language->language) {
    case 'es':
      $name_sitp_image = 'tm_da_sitp_image_es';
      $name_sitp_link = 'tm_da_sitp_link_es';
      $name_image_dics = 'tm_da_disability_image_es';
      $name_link_dics = 'tm_da_disability_link_es';
      break;

    case 'en':
      $name_sitp_image = 'tm_da_sitp_image_en';    
      $name_sitp_link = 'tm_da_sitp_link_en';
      $name_image_dics = 'tm_da_disability_image_en';
      $name_link_dics = 'tm_da_disability_link_en';
      break;    
  }
  $image_sitp = _tm_blocks_get_image($name_sitp_image, 'tm_da_sitp_style', t('Data SITP'), t('Data SITP'));
  $image_video = _tm_blocks_get_image('tm_b_video_image', 'tm_b_video_style', t('Videos'), t('Videos'));
  $image_dics = _tm_blocks_get_image($name_image_dics, 'tm_da_disability_style', t('Disability'), t('Disability'));
  //$image_video_link = _tm_get_uri_last_video_gallery();
  $content['galleries'] = array(
    '#prefix' => '<div class="tm-ho-galleries">',
    '#suffix' => '</div>',
    'images' => array(
      '#prefix' => '<div class="tm-ho-img-galleries">',
      '#suffix' => '</div>',
      '#markup' => views_embed_view('galleries', 'block_1'),
    ),
    'container' => array(
      '#prefix' => '<div class="tm-gallerie-tumb">',
      '#suffix' => '</div>',
      'da_sitp' => array(
        '#prefix' => '<div class="tm-ho-da-sitp">',
        '#suffix' => '</div>',
        '#markup' => l(render($image_sitp), variable_get($name_sitp_link, '</front>'), array(
          'attributes' => array(
            'class' => array('tm-sitp-link'),
          ),
          'html' => TRUE,
        )),
      ),
      'video' => array(
        '#prefix' => '<div class="tm-ho-video-galleries">',
        '#suffix' => '</div>',
        //'#markup' => l(render($image_video), $image_video_link, array(
          '#markup' => l(render($image_video), 'http://transmilenio.com.co/es/videos-youtube', array(
          'attributes' => array(
            'class' => array('tm-video-link'),
          ),
          'html' => TRUE,
        )),
      ),
    ),
    'disc' => array(
      '#prefix' => '<div class="tm-ho-img-galleries-dis">',
      '#suffix' => '</div>',
      '#markup' => l(render($image_dics), variable_get($name_link_dics, '</front>'), array(
        'attributes' => array(
          'class' => array('tm-disability-link'),
        ),
        'html' => TRUE,
      )),
    ),
  );
  return $content;
}

/**
 * Micro Menu.
 */
function _tm_blocks_get_menu_submenu() {
  $content = array();
  // $node = menu_get_object('node');
  // if ($node) {
  //   $field_type = field_get_items('node', $node, 'field_type');
  //   if ($field_type[0]['value'] == 'Get moving Bogota') {
  //     $content['menu'] = array(
  //       '#type' => 'html_tag',
  //       '#tag' => 'div',
  //       '#value' => views_embed_view('lateral_menus', 'block_1'),
  //     );
  //   }
  //   elseif ($field_type[0]['value'] == 'System news') {
  //     $content['menu'] = array(
  //       '#type' => 'html_tag',
  //       '#tag' => 'div',
  //       '#value' => views_embed_view('lateral_menus', 'block'),
  //     );
  //   }
  //   else {
  //     $content = _get_micro_menu();
  //   }
  // }
  // else {
    
    $content = _get_micro_menu($content);

  // }
  return $content;
}

/**
 * Get curent menu from main menu.
 */
function _get_micro_menu($content) {
  $menu_trail = menu_get_active_trail();
  
  if (count($menu_trail) < 2) {
    return $content;
  }
  end($menu_trail);
  $last_item = current($menu_trail);
  if (count($menu_trail) > 3) {
    prev($menu_trail);
  }
  $current_page_parent = prev($menu_trail);
  $main_menu = menu_tree_page_data('main-menu');
  
  for ($i = 1; $i < $last_item['depth']; $i++) {
    foreach ($main_menu as $menu_item) {
      if ($menu_item['link']['mlid'] == $last_item['p' . $i]) {
        $main_menu = $menu_item['below'];
        break;
      }
    }
  }
 
  return menu_tree_output($main_menu);
}
/**
 * Get image config.
 */
function _tm_blocks_get_image($image, $image_style, $alt, $title) {
  $content = array();
  $image_second = array();
  $image_fid = variable_get($image, '');
  $image = file_load($image_fid);
  $image_style = image_style_load(variable_get($image_style, 'thumbnail'));
  $image_width = 0;
  $image_height = 0;
  foreach ($image_style['effects'] as $effect) {
    if (($effect['name'] == 'image_scale_and_crop') || ($effect['name'] == 'image_scale')) {
      $image_width = $effect['data']['width'];
      $image_height = $effect['data']['height'];
      break;
    }
  }
  if ($image) {
    $image_second = array(
      '#theme' => 'image_style',
      '#style_name' => $image_style['name'],
      '#path' => $image->uri,
      '#width' => $image_width,
      '#height' => $image_height,
      '#alt' => $alt,
      '#title' => $title,
      '#attributes' => array(
        'class' => array(drupal_html_class('tm-image-style')),
      ),
    );
  }
  return $image_second;
}

/**
 * Get last image gallery tid.
 */
function _tm_get_uri_last_video_gallery() {
  global $language;
  $query = new EntityFieldQuery();
  $result = $query->entityCondition('entity_type', 'node')
    ->propertyCondition('status', 1)
    ->entityCondition('bundle', 'gallery')
    ->propertyCondition('language', $language->language)
    ->fieldCondition('field_galley_type', 'value', 'video')
    ->propertyOrderBy('created', 'DESC')
    ->range(0, 1)
    ->execute();
  if (isset($result['node'])) {
    return 'node/' . reset($result['node'])->nid;
  }
  else {
    return '</front>';
  }
}

/**
 * Get Bogotá humana logo.
 */
function _tm_blocks_get_bogota_humana_logo() {
  $content = array();
  $vars = array(
    'path' => drupal_get_path('module', 'tm_blocks') . '/images/Alcaldia bogota humana.jpg',
    'width' => 185,
    'height' => 60,
    'alt' => t('Bogotá humana'),
    'title' => t('Bogotá humana'),
    'attributes' => array(
      'class' => array('tm-bogota-humana-logo'),
    ),
  );
  $content['bh_logo'] = array(
    '#prefix' => '<div class="tm-bogota-humana">',
    '#suffix' => '</div>',
    '#markup' => l(theme('image', $vars), 'http://www.bogotahumana.gov.co', array(
      'attributes' => array(
        'target' => '_blank',
        'class' => array('bh-logo-link'),
      ),
      'html' => TRUE
      )
    ),
  );
  return $content;
}

/**
 * Get Bogotá humana logo.
 */
function _tm_blocks_get_colombian_emblem_logo() {
  $content = array();
  global $base_url;
  $path = $base_url . '/' . drupal_get_path('module', 'tm_blocks') . '/images/colombian_emblem.png';

  $vars = array(
    'path' => $path,
    'width' => 185,
    'height' => 60,
    'alt' => t('Colombian emblem'),
    'title' => t('Colombian emblem'),
    'attributes' => array(
      'class' => array('tm-colombian-emblem-logo'),
    ),
  );
  $content['bh_logo'] = array(
    '#prefix' => '<div class="tm-colombian-emblem">',
    '#suffix' => '</div>',
    /*'#markup' => l(theme('image', $vars), 'http://www.bogotahumana.gov.co', array(
      'attributes' => array(
        'target' => '_blank',
        'class' => array('bh-logo-link'),
      ),
      'html' => TRUE
      )
    ),*/
    '#markup' => theme('image', $vars),
  );
  return $content;
}

function _tm_blocks_get_last_update(){
  //query returns last node changed date
  $format2 = 'g:i a';
  $query = db_select('node', 'n');
  $query->fields('n');
  $query->condition('status', 1);
  $query->orderBy('changed', 'DESC');
  $query->range(0,1);
  $result = $query->execute();
 
  $res = $result->fetchAssoc();

  /*$record = $result->fetchAssoc()) {
        dpm($record);
  }*/
  $string  = t('Last update : ') ;
  $markup =  $string . date('d-m-Y',$res['changed']);
  

  return $markup;
}
/**
 * Page Title Callback.
 */
function _tm_blocks_get_page_title() {
  $block_title = '';
  $hideclass = '';
  $show = TRUE;
  if (drupal_get_title()) {
    $block_title = t(drupal_get_title());
  }
  else {
    $current_trail = menu_get_active_trail();
    if ($current_trail) {
      $last = end($current_trail);
      $block_title = isset($last['title']) ? $last['title'] : $last['link_title'];
    }
  }
  if (drupal_is_front_page()) {
    $hideclass = 'element-invisible';
  }
  $content['title_container'] = array(
    '#type' => 'container',
    '#attributes' => array(
      'class' => array(drupal_html_class('tm-page-title-container')),
    ),
  );
  $node = menu_get_object();
  if (isset($node) && $node->type && ($node->type == 'article' || $node->type == 'gallery')) {
    $show = FALSE;
  }
  if ($show) {
    $content['title_container']['title'] = array(
      '#type' => 'html_tag',
      '#tag' => 'h1',
      '#value' => $block_title,
      '#attributes' => array(
        'class' => array(drupal_html_class('tm-page-title'), $hideclass),
      ),
    );
  }
  return $content;
}

/**
 * Get certifications image.
 */
function _tm_blocks_get_tm_certifications() {
  $content = array();
  $vars = array(
    'path' => drupal_get_path('module', 'tm_blocks') . '/images/TransmilenioCertificaciones.png',
    'width' => 300,
    'height' => 60,
    'alt' => t('Certificaciones Transmilenio'),
    'title' => t('Certificaciones Transmilenio'),
    'attributes' => array(
      'class' => array('tm-certifications-img'),
    ),
  );
  $content['tm_certs'] = array(
    '#prefix' => '<div class="tm-certifications">',
    '#suffix' => '</div>',
    '#markup' => theme('image', $vars),
  );
  return $content;
}

/**
 * All News.
 */
function _tm_blocks_all_news() {
  $content = array();
  $content['tm_link'] = array(
    '#markup' => l(t(variable_get('tm_all_news_text', 'Nothing')), variable_get('tm_all_news_link', '#')),
  );
  return $content;
}

/**
 * All Events.
 */
function _tm_blocks_all_events() {
  $content = array();
  $content['tm_link'] = array(
    '#markup' => l(t(variable_get('tm_all_events_text', 'Nothing')), variable_get('tm_all_events_link', '#')),
  );
  return $content;
}

function tm_institutional_block(){

  $institutional_script = variable_get('institutional_block');

  $content = array();
  
  $content['tm_scripts'] = array(
    '#prefix' => '<div class="tm-scripts">',
    '#suffix' => '</div>',
    '#markup' => $institutional_script,
  );

  return $content;
}
